' BandWidth.bas for FilmStar DESIGN, MEASURE 32-bit
' Copyright 1995-2000 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' To use this program, first calculate a spectrum or load one from disk.
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   BandPass Filter
'   Command       basrun c:\winfilm\basic\bandwidth.bas;
'
DefInt I-N
DefSng A-H, O-Z

Sub Main
    Dim kErr As Boolean
    Busy True
    ' Calculate within range wMin, wMax as shown in FilmStar DESIGN screen
    ' This allows the spectral data set to be larger than the displayed axes
    ' when there are several peaks to be considered
    AxesRange wMin, wMax
    BandMax wMin, wMax, b, kErr
    If Not kErr Then BandCtr wMin, wMax, c, kErr        ' mean wavelength
    'If Not kErr Then BandCtr wMin, wMax, c, kErr, 1    ' average wavelength
    If Not kErr Then BandWidth 1, wMin, wMax, b1, kErr
    If Not kErr Then BandWidth 5, wMin, wMax, b5, kErr
    If Not kErr Then BandWidth 20, wMin, wMax, b20, kErr
    If Not kErr Then BandWidth 50, wMin, wMax, b50, kErr
    If Not kErr Then BandWidth 80, wMin, wMax, b80, kErr
    If Not kErr Then
        s$ = "Maximum " & Format$(100 * b,"0.00") & "%" & vbCrLf
        s$ = s$ &  "Center " & Format$(c,"0.00") & " nm" & vbCrLf
        s$ = s$ &  "1% Bandwidth " & Format$(b1, "0.00") & " nm" & vbCrLf
        s$ = s$ &  "5% Bandwidth " & Format$(b5, "0.00") & " nm" & vbCrLf
        s$ = s$ &  "20% Bandwidth " & Format$(b20, "0.00") & " nm" & vbCrLf
        s$ = s$ &  "50% Bandwidth " & Format$(b50, "0.00") & " nm" & vbCrLf
        s$ = s$ &  "80% Bandwidth " & Format$(b80, "0.00") & " nm" & vbCrLf
        Display s$, "Bandwidth Calculation", 5000, 3000, "Arial", 10, 1
    Else
        Display "----Error----", "Bandwidth Calculation", 6000, 4000, "Arial", 36, 1
    End If
    Busy False
End Sub

Sub AxesRange(wMin, wMax)
    k = Macro("AxesCopy;")
    s$ = Clipboard$()
    k = InStr(s$, vbTab)
    wMin = Val(Mid$(s$, 1, k -1))
    s$ = Mid$(s$, k + 1)
    k = InStr(s$, vbTab)
    wMax = Val(Mid$(s$, 1, k -1))
End Sub

