'#Reference {00020813-0000-0000-C000-000000000046}#1.7#0#C:\Program Files (x86)\Microsoft Office\Office14\EXCEL.EXE#Microsoft Excel 14.0 Object Library
' ExcelTable.bas for FilmStar DESIGN
' Copyright 2005-2012 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program creates a spectral data table in Excel
' It illustrates the use of BASIC Sub GetTableData
'
Option Explicit
DefInt I-N
DefDbl A-H, O-Z

Sub Main()
    Dim Wave, Ang, Rs, Rp, Ts, Tp, Ars, Arp, Ats, Atp
    Dim kRow, kCol
    ' Declare object variables for Microsoft Excel,
    ' application workbook, and worksheet objects.

    ' ***************************************************************
    ' If you get an error in the next line, you need to re-establish
    ' a reference to the Microsoft Excel Object Library
    ' ***************************************************************

    Dim xlApp As Excel.Application
    Dim xlBook As Excel.Workbook
    Dim xlSheet As Excel.Worksheet
    ' Assign object references to the variables. Use
    ' Add methods to create new workbook and worksheet
    ' objects.
    Set xlApp = New Excel.Application
    Set xlBook = xlApp.Workbooks.Add
    Set xlSheet = xlBook.Worksheets.Add
    xlSheet.Name = "DESIGN Data"
    xlApp.Visible=True
    xlSheet.Cells(1, 1) = "W nm"
    kRow = 1
    For Wave = 400 To 800 Step 5
        kRow = kRow + 1
        xlSheet.Cells(kRow, 1) = Wave
    Next Wave
    For Ang = 0 To 30 Step 10
        kCol = kCol + 2
        xlSheet.Cells(1, kCol) = "Rp " & CStr(Ang) & ""
        xlSheet.Cells(1, kCol + 1) = "Rs " & CStr(Ang) & ""
        kRow = 1
        For Wave = 400 To 800 Step 5
            kRow = kRow + 1
            GetTableData Wave, Ang, Rs, Rp, Ts, Tp, Ars, Arp, Ats, Atp
            xlSheet.Cells(kRow, kCol) = Rp
            xlSheet.Cells(kRow, kCol + 1) = Rs
        Next Wave
    Next Ang
    AppActivate "Microsoft Excel"
    ' Release objects.
    Set xlApp = Nothing
    Set xlBook = Nothing
    Set xlSheet = Nothing
End Sub




