' LAYCALC.BAS for FilmStar DESIGN
' Copyright 1996-2001 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program generates repeated plots where a layer is
' varied in thickness from a minimum to maximum value
'
Option Explicit
DefInt i-N
DefSng A-H, O-Z
Dim i, iLay, nLay, q(), qt$(), qd$(), qInc, qMin, qMax, qVal, s$
Dim Col(0 To 7) As String * 1, kCol, kAxs
    
Sub Main    
    Col(0) = "K": Col(1) = "B": Col(2) = "C": Col(3) = "G"
    Col(4) = "R": Col(5) = "M": Col(6) = "Y": Col(7) = "W"
    iLay = Val(IniString("LayerCalc", "LayerNum"))
    If iLay = 0 Then iLay = 1
    kCol = Val(IniString("LayerCalc", "LineColor"))
    kAxs = Val(IniString("LayerCalc", "NewAxes"))
    qMin = Val(IniString("LayerCalc", "ThickMin"))  
    qMax = Val(IniString("LayerCalc", "ThickMax"))  
    qInc = Val(IniString("LayerCalc", "ThickInc"))  
    Do
        GetLayerNum
        MainActivate
        Evaluate
    Loop
End Sub
    
Sub GetLayerNum
    Dim ColBox$(7)
    ColBox$(0) = "Black": ColBox$(1) = "Blue": ColBox$(2) = "Cyan"
    ColBox$(3) = "Green": ColBox$(4) = "Red" : ColBox$(5) = "Magenta"
    ColBox$(6) = "Yellow": ColBox$(7) = "White"
    On Error GoTo Quit  ' cancel button pressed
    GetLayers nLay, q(), qt(), qd() ' DESIGN subroutine
    If iLay > nLay Then iLay = nLay
    Begin Dialog UserDialog 420,203,"DESIGN Layer Calculator",.DialogFunc
        Text 30,22,90,21,"Layer &Number",.LayNumLbl
        TextBox 134,20,70,21,.LayNumTxt
        Text 64,52,60,14,"Mi&nimum",.Field1
        TextBox 134,50,70,21,.MinTxt
        Text 60,82,60,14,"Ma&ximum",.Field3
        TextBox 134,80,70,21,.MaxTxt
        Text 54,112,70,21,"&Increment",.IncLbl
        TextBox 134,110,70,21,.IncTxt
        Text 214,22,80,21,"",.DesignLbl
        Text 54,142,70,21,"Line &Color",.Field2
        DropListBox 134,141,90,63,ColBox(),.ColLst
        CheckBox 134,170,110,14,"Redraw &Axes",.AxesChk
        OKButton 310,20,80,24
        CancelButton 310,54,80,24
    End Dialog
    Dim dlg As UserDialog
    With dlg
        .LayNumTxt = CStr(iLay) ' layer number
        .MinTxt = CStr(qMin)    ' minimum thickness
        .MaxTxt = CStr(qMax)    ' maximum thickness
        .IncTxt = CStr(qInc)    ' layer Increment
        .ColLst = kCol          ' color?
        .AxesChk = kAxs         ' draw new axes?
    End With
    Dialog dlg
    With dlg
        iLay = Val(.LayNumTxt)
        qInc = Val(.IncTxt)
        qMin = Val(.MinTxt)
        qMax = Val(.MaxTxt)
        kCol = .ColLst
        kAxs = .AxesChk
    End With
    Exit Sub
Quit:
    WriteIniString "LayerCalc", "LayerNum", CStr(iLay)
    WriteIniString "LayerCalc", "LineColor", CStr(kCol)
    WriteIniString "LayerCalc", "NewAxes", CStr(kAxs)
    WriteIniString "LayerCalc", "ThickMin", CStr(qMin)
    WriteIniString "LayerCalc", "ThickMax", CStr(qMax)
    WriteIniString "LayerCalc", "ThickInc", CStr(qInc)
    BasActivate
    End
End Sub

Sub Evaluate
    Dim q0!
    On Error Resume Next
    If kAxs = 1 Then AxesDraw
    LineColor Col(kCol)
    CalcPlotStart
    q0 = q(iLay)
    If qMin < 0 Then qMin = 0
    If qInc > 0 Then
        For qVal = qMin To qMax Step qInc
            q(iLay) = qVal  
            SetLayers q(), qt()
            CalcPlot
        Next qVal
    End If
    q(iLay) = q0    ' restore original design
    SetLayers q(), qt() ' DESIGN subroutine
    CalcPlotDone
End Sub

Function DialogFunc%(DlgItem$, Action%, SuppValue%)
    Select Case Action%
    Case 1 ' initialization
        DlgText "DesignLbl", CStr(q(iLay)) & qt$(iLay)
        DlgText "LayNumTxt", CStr(iLay)
        DlgText "MinTxt", CStr(qMin)
        DlgText "MaxTxt", CStr(qMax)
        DlgText "IncTxt", CStr(qInc)
        DlgValue "AxesChk", kAxs
        DlgValue "ColLst", kCol
    Case 3 ' text box change
        Select Case DlgItem
        Case "LayNumTxt"
            s$ = DlgText$(DlgItem)
            i = Val(s$)
            If i > 0 And i <= nLay Then
                DlgText "DesignLbl", CStr(q(i)) & qt$(i)
            Else
                DlgText "DesignLbl", ""
            End If
        End Select
    End Select
End Function
