' LayersExp.bas for FilmStar DESIGN
' Copyright 2017-2018 FTG Software Associates
' Revised 07/26/18 with FileSaveAll and FileOpenAll
'
' This program exports a list of physical thicknesses and materials
'
Option Explicit
Option Base 1

Const ExpPath$ = PgmPath$ & "\Export"  ' usually c:\Winfilm\Export

Sub Main
    Dim i%, nl%, q!(), qt$(), qd$(), file$, des$
    file$ = GetFilePath(FileName$(8), "tab", ExpPath$, "Layers Export", 3)
    If Len(file$) > 0 Then
        FileSaveAll
        DesignConvert 1, "N" ' convert to nm physical thickness
        GetLayers nl, q(), qt$(), qd$(), 2  ' get design layers
        If nl > 0 Then
            Open file$ For Output As #1
            For i = 1 To nl
                Print #1, CStr(i) & vbTab & qd$(i) & vbTab & Format$(q(i), "0.000") & " nm"
            Next i
            Close #1
        Else
            MsgBox "No layers to export", vbInformation, "Export Layers"
        End If
        FileOpenAll
    End If
End Sub

