' Mselect.Bas for FilmStar DESIGN
' Copyright 1995-2010 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program illustrates how a macro can run other macros
' Similar to MselectPop.bas but uses list box instead of pop-up menu

Option Explicit
DefInt I-N
DefSng A-H, O-Z
Dim kLast ' last macro that was run

Sub Main
    Do
        GetMacro
    Loop
End Sub

Sub GetMacro
    On Error GoTo QuitToFilmStar ' press Cancel to quit
    Dim c$, MacroList$(8), MacroCmd$(8)
    ' ****** Use BASCHAIN instead of BASRUN or BASOPEN in BASIC macro commands ******
    c$ = "BasChain " & PgmPath & "\Basic32\"
    MacroList(0) = "45 deg, S + P"
    MacroCmd(0) = "axesdraw;plotstart;angle 45 p;linecolor r;calcplot;angle 45 s;linecolor b;calcplot;plotdone;"
    MacroList(1) = "F Number"
    MacroCmd(1) = c$ & "fnum32.bas;"
    MacroList(2) = "Print Catalog"
    MacroCmd(2) = c$ & "catalog.bas;"
    MacroList(3) = "Bandpass Filter Analysis"
    MacroCmd(3) = c$ & "bandwidth.bas;"
    MacroList(4) = "Gaussian Monochromator"
    MacroCmd(4) = c$ & "gaussian.bas;"
    MacroList(5) = "Rugate Design"
    MacroCmd(5) = c$ & "rugate.bas;"
    MacroList(6) = "Restore Original Directories"
    MacroCmd(6) = c$ & "inipath.bas;"
    MacroList(7) = "Report Generator Template"
    MacroCmd(7) = c$ & "template.bas;"
	Begin Dialog UserDialog 440,182,"Run FilmStar Macro" ' %GRID:10,7,1,1
		Text 40,18,150,15,"Macro &Description"
		ListBox 40,35,240,126,MacroList(),.MacRun
		OKButton 320,35,90,28
		CancelButton 320,70,90,28
	End Dialog
    Dim dlg As UserDialog
    dlg.MacRun = kLast
    Dialog dlg
    kLast = dlg.MacRun
    Macro MacroCmd(kLast) ' FilmStar DDE macro command
    Exit Sub
QuitToFilmStar:
    End
End Sub

