'#Reference {00020813-0000-0000-C000-000000000046}#1.3#0#C:\Program Files\Microsoft Office\Office\EXCEL9.OLB#Microsoft Excel 9.0 Object Library
' Dialog.bas
' FTG Software 13 Feb 06
'
' This program is intended to be compared with DialogXL.bas which uses
' an Excel dialog instead of the native FilmStar BASIC dialog
'
Option Explicit
'
Dim szDate As String, szBatch As String, kID, szSubs As String

Sub Main
    Do
    Loop Until UserInputOK()
End Sub

Function UserInputOK() As Boolean
    On Error GoTo CancelClick
	Begin Dialog UserDialog 290,145,"Normal Data Entry" ' %GRID:5,5,1,1

		Text 45,20,95,15,"&Date (yymmdd)",.lblDate,1
		TextBox 150,19,90,19,.txtDate

		Text 45,50,95,15,"&Batch",.lblBatch,1
		TextBox 150,49,90,19,.txtBatch

		Text 15,80,125,15,"&ID Number",.lblID,1
		TextBox 150,79,90,19,.txtID

		OKButton 45,115,75,20
		CancelButton 160,115,80,20
	End Dialog
    Dim dlg As UserDialog
    With dlg
        If IsBlank(szDate) Then     ' default is today's date
            .txtDate = Right$(CStr(Year(Date)), 2) & Format$(Month(Date), "00") & Format$(Day(Date), "00")
        Else
            .txtDate = szDate
        End If
        .txtBatch = szBatch
        .txtID = "1"      ' starting number
    End With
    On Error GoTo CancelClick
    Dialog dlg
    On Error Resume Next
    With dlg
        szDate = .txtDate
        szBatch = .txtBatch
        kID = CInt(.txtID)
    End With
    UserInputOK = True
    If MsgBox("Date: " & szDate & vbLf & "Batch: " & szBatch & vbLf & "Starting ID Number: " & CStr(kID) & _
      vbLf & vbLf & "Are these entries correct?", vbYesNo + vbQuestion, "Verify Input") = vbYes Then
        '
        ' Do something useful
        '
    Else
        UserInputOK = False ' re-enter data
    End If
    Exit Function
CancelClick:
    If MsgBox("Exit program?", vbYesNo + vbQuestion, "Dialog Example") = vbYes Then
        End
    Else
        UserInputOK = False
    End If
    Exit Function
End Function

Function IsBlank(ByVal a$) As Boolean
    IsBlank = (Len(Trim$(a$)) = 0)
End Function

