' Program LayerIndexList.bas for FilmStar DESIGN
' Copyright 2009 FTG Software
' Exports design layers and index tables
'  
' NOTE: Indices can be expressed as constants, dispersive
'       functions or look-up tables

Option Explicit
Option Base 1

Sub Main
    Open "C:\Winfilm\Design.txt" For Output As #1
    DesignList
    nkTableList
    Close #1
End Sub

Sub DesignList
    Dim i%, nLayers%, q!(), qSymb$(), qDesc$()
    GetLayers nLayers, q(), qSymb$(), qDesc$()
    For i = 1 To nLayers
        Print #1, Format$(q(i), "0.0####") & qSymb$(i)
    Next i
End Sub

Sub nkTableList
    Dim i%, nMatl%, w!, w1!, w2!, xn!, xk!
    Dim nSymb$(), nTyp$(), nFile$(), nDesc$()
    GetIndexList nSymb$(), nTyp$(), nFile$(), nDesc$()
    nMatl = UBound(nFile$)
    GetWaveRange w1, w2   ' get current wavelength range
    For i = 1 To nMatl
        Print #1, vbCrLf & nSymb$(i) & ": " & nDesc$(i)
        For w = w1 To w2 Step 5   ' 5 nm increment...change as required
            GetIndex nSymb$(i), w, xn, xk
            Print #1, Format$(w, "0.00") & ", " & _
            Format$(xn, "0.0000") & ", " & Format$(xk, "0.00000")
        Next w
    Next i
End Sub
