' MULTR32.BAS for FilmStar DESIGN 32-bit
' Copyright 1997-2001 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program evaluates multiple-bounce reflectance devices
'
Option Base 1
DefInt I-N
DefSng A-H, O-Z
Dim ydata(), ytmp(), nData, legend

Sub Main
    AxesDraw
    CalcPlot
    ydata = Spectrum_Y   ' get spectrum
    nData = UBound(ydata, 1)
    ReDim ytmp(nData,2)
    PlotClose     ' erase any current graphs
    PlotActivate  ' activate FSPlot window
    PlotSize 9500, 7500, 75  ' fix window size
    PlotLegendOn 1
' Put up to 12 cases below
    Bounce 1
    Bounce 2
    Bounce 4
    Bounce 8
    Bounce 16
    Bounce 32
End Sub

Sub Bounce(nBounce)
    legend = legend + 1
    For j = 1 To nData
        ytmp(j,1) = ydata(j,1)^nBounce
    Next j
    Spectrum_Y = ytmp    
    If legend = 1 Then
        PlotLegend(1) = "Original"
    Else
        PlotLegend(legend) = CStr(nBounce) & " Bounces"
    End If
    PlotNext
End Sub
